Index: /utils/tools/NESTING/src/agrif_create_bathy.f90
===================================================================
--- /utils/tools/NESTING/src/agrif_create_bathy.f90	(revision 10024)
+++ /utils/tools/NESTING/src/agrif_create_bathy.f90	(revision 10025)
@@ -13,4 +13,5 @@
   USE agrif_partial_steps
   USE agrif_connect_topo
+  USE agrif_interpolation
   !
   IMPLICIT NONE
@@ -40,21 +41,21 @@
   !      
   CHARACTER(len=80) :: namelistname
-  CHARACTER*100 :: Childmeter_file,Childlevel_file,Child_coordinates,child_ps     
-  LOGICAL,DIMENSION(:,:),POINTER :: masksrc => NULL()  
+  CHARACTER*100     :: Childmeter_file,Childlevel_file,Child_coordinates,child_ps, Child_domcfg    
   LOGICAL :: identical_grids     
-  INTEGER,DIMENSION(:,:),ALLOCATABLE ::mask_oce,trouble_points
   INTEGER :: i,j,num_links,nb,nbadd,status,narg,iargc     
-  INTEGER,DIMENSION(:),POINTER :: src_add,dst_add => NULL() 
-  INTEGER :: numlatfine,numlonfine,numlat,numlon,pos,pos2
-  REAL*8,DIMENSION(:,:),POINTER :: matrix,interpdata => NULL()     
-  REAL*8, DIMENSION(:,:),POINTER :: bathy_fin_constant => NULL()  
-  REAL*8,DIMENSION(:,:),ALLOCATABLE :: bathy_test,vardep,glamhr,gphihr
-  REAL*8,DIMENSION(:),ALLOCATABLE :: vardep1d
-  REAL*8, DIMENSION(:,:),POINTER :: gdepw_ps_interp => NULL() 
-  REAL*8, DIMENSION(:,:),POINTER :: save_gdepw,rx,ry,maskedtopo
+  INTEGER :: jpj,jpi,pos,pos2
+  LOGICAL,DIMENSION(:,:),POINTER     :: masksrc => NULL()  
+  INTEGER,DIMENSION(:,:),ALLOCATABLE :: mask_oce,trouble_points
+  INTEGER,DIMENSION(:)  ,POINTER     :: src_add,dst_add => NULL() 
+  REAL*8, DIMENSION(:,:),POINTER     :: matrix,interpdata => NULL()     
+  REAL*8, DIMENSION(:,:),POINTER     :: bathy_fin_constant => NULL()  
+  REAL*8, DIMENSION(:,:),ALLOCATABLE :: bathy_test,vardep,glamhr,gphihr
+  REAL*8, DIMENSION(:)  ,ALLOCATABLE :: vardep1d
+  REAL*8, DIMENSION(:,:),POINTER     :: gdepw_ps_interp => NULL() 
+  REAL*8, DIMENSION(:,:),POINTER     :: save_gdepw,rx,ry,maskedtopo
   REAL*8  :: Cell_lonmin,Cell_lonmax,Cell_latmin,Cell_latmax,wghts
-  LOGICAL :: Pacifique=.FALSE.
+  LOGICAL :: Pacifique = .FALSE.
   INTEGER :: boundary,xpos,ypos,iimin,iimax,jjmax,jjmin
-  INTEGER :: nbloops,nxhr,nyhr,ji,jj,nbiter,nbloopmax
+  INTEGER :: nxhr,nyhr,ji,jj,nbiter
   INTEGER :: ipt,jpt,iloc,jloc
   INTEGER, DIMENSION(2) :: i_min,i_max,j_min,j_max
@@ -70,216 +71,201 @@
   !
   ! read input file (namelist.input)
-  !
   CALL read_namelist(namelistname)
   !      
   ! define names of child grid files
+  CALL set_child_name(parent_coordinate_file,Child_coordinates) 
+  IF( TRIM(parent_meshmask_file) .NE. '/NULL' )    CALL set_child_name(parent_meshmask_file,Childlevel_file)            
+  IF( TRIM(parent_meshmask_file) .NE. '/NULL' )    CALL set_child_name(parent_domcfg_output,Child_domcfg) 
   !
-  CALL set_child_name(parent_coordinate_file,Child_coordinates) 
-  IF( TRIM(parent_meshmask_file) .NE. '/NULL' ) &
-       CALL set_child_name(parent_meshmask_file,Childlevel_file)            
-  !
-  !
-  !
-  !
-  !
-  !------------------------------------------------------------------
-  ! ****First option : no new topo file / no partial steps
-  ! interpolate levels directly from parent file
-  !------------------------------------------------------------------
-  !
-  !
-  !
-  !
-  !
-  !
-  IF(.NOT.new_topo .AND. .NOT.partial_steps) THEN      
+  !                                                   ! ------------------------------------------------------------------
+  IF( .NOT.new_topo .AND. .NOT.partial_steps ) THEN   ! **** First option : no new topo file & no partial steps
+     !                                                !                 ==> interpolate levels directly from parent file
+     !                                                ! ------------------------------------------------------------------
+     WRITE(*,*) '*** First option: no new topo file & no partial steps'
      !      
-     WRITE(*,*) 'First option'
-     !read coarse grid bathymetry and coordinates file
-     !           
-     WRITE(*,*) 'No new topo file ...'
+     ! read coarse grid bathymetry and coordinates
      status = Read_Coordinates(TRIM(parent_coordinate_file),G0)    
      status = Read_bathy_level(TRIM(parent_meshmask_file),G0)
      !           
-     IF( imax > SIZE(G0%glamt,1) .OR. jmax > SIZE(G0%glamt,2) .OR. &
-          imax <= imin .OR. jmax <= jmin ) THEN                   
+     ! read fine grid coordinates
+     status = Read_Coordinates(TRIM(Child_coordinates),G1,pacifique)
+     !
+     ! stop if error in size
+     IF( imax > SIZE(G0%glamt,1) .OR. jmax > SIZE(G0%glamt,2) .OR. imax <= imin .OR. jmax <= jmin ) THEN                   
         WRITE(*,*) 'ERROR ***** bad child grid definition ...'
         WRITE(*,*) 'please check imin,jmin,imax,jmax,jpizoom,jpjzoom values'       
-        WRITE(*,*) ' '
         STOP
      ENDIF
-     !
-     !read fine grid coordinates file
-     !      
-     status = Read_Coordinates(TRIM(Child_coordinates),G1,pacifique)
-     !  
      IF( SIZE(G1%nav_lon,1) .NE. nxfin .OR. SIZE(G1%nav_lon,2) .NE. nyfin ) THEN
-        !
         WRITE(*,*) 'ERROR ***** bad child coordinates file ...'
-        WRITE(*,*) ' '
-        WRITE(*,*) 'please check that child coordinates file '
-        WRITE(*,*) 'has been created with the same namelist '
-        WRITE(*,*) ' '
+        WRITE(*,*) 'please check that child coordinates file has been created with the same namelist'
         STOP
-        !
-     ENDIF
-     !
-     numlat =  SIZE(G0%nav_lat,2)
-     numlon =  SIZE(G0%nav_lat,1)    
-     numlatfine =  SIZE(G1%nav_lat,2)
-     numlonfine =  SIZE(G1%nav_lat,1)  
+     ENDIF
+     !
+     jpj = SIZE(G0%nav_lat,2)
+     jpi = SIZE(G0%nav_lat,1)    
      !           
-     ALLOCATE(masksrc(numlon,numlat))
-     !
      ! create logical array masksrc
-     !
-     WHERE(G0%bathy_level.LE.0) 
-        masksrc = .FALSE.
-     ELSEWHERE
-        masksrc = .TRUE.
+     ALLOCATE(masksrc(jpi,jpj))
+     WHERE(G0%bathy_level.LE.0)   ;   masksrc = .FALSE.   ;
+     ELSEWHERE                    ;   masksrc = .TRUE.    ;
      END WHERE
 
+     ! change longitudes (from -180:180 to 0:360)
      IF ( Pacifique ) THEN
-        WHERE(G0%nav_lon < 0.001) 
-           G0%nav_lon = G0%nav_lon + 360.
-        END WHERE
-     ENDIF
-
-
-     !-----------------          
-     ! compute remapping matrix thanks to SCRIP package
-     !
-     ! remapping process
-     !              
+        WHERE(G0%nav_lon < 0.001)   G0%nav_lon = G0%nav_lon + 360.
+     ENDIF
+
+     ! From levels to meters
      ALLOCATE(G1%bathy_meter(nxfin,nyfin))
      CALL levels_to_meter(G0)
      !             
-     !             Call levels_to_meter(G1)
-     !             
-     CALL get_remap_matrix(G0%nav_lat,G1%nav_lat,   &
-          G0%nav_lon,G1%nav_lon,   &
-          masksrc,matrix,src_add,dst_add)
-     CALL make_remap(G0%bathy_meter,G1%bathy_meter,nxfin,nyfin, &
-          matrix,src_add,dst_add)  
-     !                                  
-     !            
+     ! compute remapping matrix thanks to SCRIP package
+     CALL get_remap_matrix(G0%nav_lat,G1%nav_lat,G0%nav_lon,G1%nav_lon,masksrc,matrix,src_add,dst_add)
+     CALL make_remap(G0%bathy_meter,G1%bathy_meter,nxfin,nyfin,matrix,src_add,dst_add)  
      DEALLOCATE(masksrc)
-     !-----------------                                      
      !      
-     ! 
      ! compute constant bathymetry for Parent-Child bathymetry connection
-     !              
      CALL init_constant_bathy(G0%bathy_meter,bathy_fin_constant)
      !
-     boundary = npt_copy*irafx + nbghostcellsfine + 1 
-     !
-     ! connection carried out by copying parent grid values for the fine points
-     ! corresponding to 3 coarse grid cells at the boundaries
-     !                 
+     ! replace child bathymetry by parent bathymetry at the boundaries
+     IF( ln_agrif_domain ) THEN
+        boundary = npt_copy*irafx + nbghostcellsfine + 1 
+     ELSE
+        boundary = npt_copy*irafx
+     ENDIF
      G1%bathy_meter(1:boundary,:) = bathy_fin_constant(1:boundary,:)
      G1%bathy_meter(:,1:boundary) = bathy_fin_constant(:,1:boundary)
      G1%bathy_meter(nxfin-boundary+1:nxfin,:) = bathy_fin_constant(nxfin-boundary+1:nxfin,:)
      G1%bathy_meter(:,nyfin-boundary+1:nyfin) = bathy_fin_constant(:,nyfin-boundary+1:nyfin)
+     DEALLOCATE(bathy_fin_constant)
      !                  
-     CALL smooth_topo(G1%bathy_meter(boundary:nxfin-boundary+1,boundary:nyfin-boundary+1),nbiter)
-     !             
+     ! bathymetry smoothing (everywhere except at the boundaries) 
+     IF( smoothing ) THEN
+        IF( ln_agrif_domain ) THEN
+           CALL smooth_topo(G1%bathy_meter(boundary:nxfin-boundary+1,boundary:nyfin-boundary+1),nbiter)
+        ELSE
+           CALL smooth_topo(G1%bathy_meter(boundary+1:nxfin-boundary,boundary+1:nyfin-boundary),nbiter)
+        ENDIF
+     ENDIF
+     !
+     ! From meters to levels
      CALL meter_to_levels(G1)
-     !             
-     DEALLOCATE(bathy_fin_constant)
-     !
-     !
-     !------------------------------------------------------------------
-     ! ****Second option : new topo file or/and partial steps     
-     !------------------------------------------------------------------ 
-     !
-     !
-     !
-     !
-     !
-     !
-     !
-     !
-  ELSE
-     !
-     WRITE(*,*) 'Second option : partial steps'
+     G1%bathy_level=NINT(G1%bathy_level)
+     !	    
+     ! Check errors in bathy
+     DO j=1,nyfin
+        DO i=1,nxfin
+           IF (G1%bathy_level(i,j).LT.0.) THEN
+              PRINT *,'error in ',i,j,G1%bathy_level(i,j)
+              STOP
+           ENDIF
+        ENDDO
+     ENDDO
+     WHERE ((G1%bathy_level.LT.3.).AND.(G1%bathy_level.GT.0.))   G1%bathy_level=3
+     !
+     ! remove closed seas
+     IF (removeclosedseas) THEN
+        ALLOCATE(bathy_test(nxfin,nyfin))
+
+        bathy_test=0.
+        WHERE (G1%bathy_level(1,:)     .GT.0.)   bathy_test(1,:)=1
+        WHERE (G1%bathy_level(nxfin,:) .GT.0.)   bathy_test(nxfin,:)=1
+        WHERE (G1%bathy_level(:,1)     .GT.0.)   bathy_test(:,1)=1
+        WHERE (G1%bathy_level(:,nyfin) .GT.0.)   bathy_test(:,nyfin)=1
+
+        nbadd = 1
+        DO WHILE (nbadd.NE.0)
+           nbadd = 0
+           DO j=2,nyfin-1
+              DO i=2,nxfin-1
+                 IF (G1%bathy_level(i,j).GT.0.) THEN
+                    IF (MAX(bathy_test(i,j+1),bathy_test(i,j-1),bathy_test(i-1,j),bathy_test(i+1,j)).EQ.1) THEN
+                       IF (bathy_test(i,j).NE.1.) nbadd = nbadd + 1
+                       bathy_test(i,j)=1.
+                    ENDIF
+                 ENDIF
+              ENDDO
+           ENDDO
+        ENDDO
+
+        WHERE (bathy_test.EQ.0.)   G1%bathy_level = 0.
+
+        DEALLOCATE(bathy_test)           
+     ENDIF
+     !
+     ! store interpolation result in output file
+     CALL levels_to_meter(G1)   ! From levels to meters
+     status = Write_Bathy_level(TRIM(Childlevel_file),G1)
+     status = write_domcfg(TRIM(Child_domcfg),G1)
+
+     WRITE(*,*) '****** Bathymetry successfully created if no new topo ******'
+     STOP
+     !
+     !                                                ! -----------------------------------------------------
+  ELSE                                                ! **** Second option : new topo file or partial steps     
+     !                                                ! ----------------------------------------------------- 
+     WRITE(*,*) '***Second option : new topo or partial steps'
+
      ! read fine and coarse grids coordinates file
-     !	    
      status = Read_Coordinates(TRIM(parent_coordinate_file),G0)
      status = Read_Coordinates(TRIM(Child_coordinates),G1,Pacifique)
-     !                        
-     IF( imax > SIZE(G0%nav_lon,1) .OR. jmax > SIZE(G0%nav_lon,2) .OR. &
-          imax <= imin .OR. jmax <= jmin ) THEN                    
+     !
+     ! check error in size
+     IF( imax > SIZE(G0%nav_lon,1) .OR. jmax > SIZE(G0%nav_lon,2) .OR. imax <= imin .OR. jmax <= jmin ) THEN                    
         WRITE(*,*) 'ERROR ***** bad child grid definition ...'
         WRITE(*,*) 'please check imin,jmin,imax,jmax,jpizoom,jpjzoom values'       
-        WRITE(*,*) ' '
         STOP
      ENDIF
-     !
-
-     !  
      IF( SIZE(G1%nav_lon,1) .NE. nxfin .OR. SIZE(G1%nav_lon,2) .NE. nyfin ) THEN
-        !
         WRITE(*,*) 'ERROR ***** bad child coordinates file ...'
-        WRITE(*,*) ' '
-        WRITE(*,*) 'please check that child coordinates file '
-        WRITE(*,*) 'has been created with the same namelist '
-        WRITE(*,*) ' '
+        WRITE(*,*) 'please check that child coordinates file has been created with the same namelist'
         STOP
-        !
-     ENDIF
-     !      
-     ! read coarse grid bathymetry file
-     !---
-     IF( new_topo ) THEN
-        WRITE(*,*) 'use new topo file : ',TRIM(elevation_database)
+     ENDIF
+     !
+     ! === From here on: G0 is the grid associated with the new topography (like gebco or etopo) ===
+     !
+     ! read bathymetry data set => G0%bathy_meter
+     IF( new_topo ) THEN                                       ! read G0%bathy_meter (on a reduced grid) and G1 coordinates
         DEALLOCATE( G0%nav_lon, G0%nav_lat )
         status = Read_bathy_meter(TRIM(elevation_database),G0,G1,Pacifique)
-     ELSE
-        WRITE(*,*) 'no new topo file'
-        status = Read_Bathymeter(TRIM(parent_bathy_meter),G0)
+     ELSE                                                      ! read G0%bathy_meter (on the global grid)
+        status = Read_Bathymeter(TRIM(parent_bathy_meter),G0)   
         IF(Pacifique) THEN
-           WHERE(G0%nav_lon < 0.0001) 
-              G0%nav_lon = G0%nav_lon + 360.
-           END WHERE
-        ENDIF
-     ENDIF
-     !---            
-     numlatfine =  SIZE(G1%nav_lat,2)
-     numlonfine =  SIZE(G1%nav_lat,1) 
-     !  
+           WHERE(G0%nav_lon < 0.0001)   G0%nav_lon = G0%nav_lon + 360.
+        ENDIF
+     ENDIF
      !               
+     ! what type of interpolation for bathymetry
+     IF( type_bathy_interp == 0 ) THEN
+        WRITE(*,*) 'Interpolation of high resolution bathymetry on child grid: Arithmetic average ...'
+     ELSE IF( type_bathy_interp == 1 ) THEN
+        WRITE(*,*) 'Interpolation of high resolution bathymetry on child grid: Median average ...'
+     ELSE IF( type_bathy_interp == 2 ) THEN     
+        WRITE(*,*) 'Interpolation of high resolution bathymetry on child grid: Bilinear interpolation ...'
+     ELSE     
+        WRITE(*,*) 'bad value for type_bathy_interp variable ( must be 0, 1 or 2 )'
+        STOP 
+     ENDIF
+     !
+     ! 1st allocation of child grid bathy
      ALLOCATE(G1%bathy_meter(nxfin,nyfin))
      G1%bathy_meter(:,:)=0.                       
-
-     WRITE(*,*) 'Interpolation of high resolution bathymetry on child grid'
-
-     IF( type_bathy_interp == 0 ) THEN
-        WRITE(*,*) 'Arithmetic average ...'
-     ELSE IF( type_bathy_interp == 1 ) THEN
-        WRITE(*,*) 'Median average ...'
-     ELSE IF( type_bathy_interp == 2 ) THEN     
-        WRITE(*,*) 'Bilinear interpolation ...'
-     ELSE     
-        WRITE(*,*) 'bad value for type_bathy_interp variable ( must be 0,1 or 2 )'
-        STOP 
-     ENDIF
-     !
-     !************************************
-     !MEDIAN AVERAGE or ARITHMETIC AVERAGE
-     !************************************
-     !
-     IF( type_bathy_interp == 0 .OR. type_bathy_interp == 1 ) THEN 
-        !
+     !
+     ! ---------------------------------------------------------------------------------
+     ! ===                 Bathymetry of the fine grid (step1)                       ===
+     ! ---------------------------------------------------------------------------------
+     ! ==> It gives G1%bathy_meter from G0%bathy_meter
+     ! ---------------------------------------------------------------------------------
+     !                                                               ! ----------------------------- 
+     IF( type_bathy_interp == 0 .OR. type_bathy_interp == 1 ) THEN   ! arithmetic or median averages
+        !                                                            ! ----------------------------- 
         ALLOCATE(trouble_points(nxfin,nyfin))
-        trouble_points = 0
-        !
-        !  POINT DETECTION
-        !
+        trouble_points(:,:) = 0
         !                       
-        DO jj = 2,numlatfine
-           DO ji = 2,numlonfine
+        DO jj = 2,nyfin
+           DO ji = 2,nxfin
               !	    
-              ! FINE GRID CELLS DEFINITION               
-              !
+              ! fine grid cell extension               
               Cell_lonmin = MIN(G1%glamf(ji-1,jj-1),G1%glamf(ji,jj-1),G1%glamf(ji,jj),G1%glamf(ji-1,jj))
               Cell_lonmax = MAX(G1%glamf(ji-1,jj-1),G1%glamf(ji,jj-1),G1%glamf(ji,jj),G1%glamf(ji-1,jj))
@@ -287,6 +273,5 @@
               Cell_latmax = MAX(G1%gphif(ji-1,jj-1),G1%gphif(ji,jj-1),G1%gphif(ji,jj),G1%gphif(ji-1,jj)) 
               !               
-              ! SEARCH FOR ALL POINTS CONTAINED IN THIS CELL
-              !
+              ! look for points in G0 (bathy dataset) contained in the fine grid cells  
               iimin = 1
               DO WHILE( G0%nav_lon(iimin,1) < Cell_lonmin ) 
@@ -302,5 +287,5 @@
               DO WHILE( G0%nav_lon(iimax,1) <= Cell_lonmax ) 
                  iimax = iimax + 1
-              iimax = MIN( iimax,SIZE(G0%bathy_meter,1))
+                 iimax = MIN( iimax,SIZE(G0%bathy_meter,1))
               ENDDO
               !                               
@@ -308,10 +293,14 @@
               DO WHILE( G0%nav_lat(iimax,jjmax) <= Cell_latmax ) 
                  jjmax = jjmax + 1
-              jjmax = MIN( jjmax,SIZE(G0%bathy_meter,2))
-
+                 jjmax = MIN( jjmax,SIZE(G0%bathy_meter,2))
               ENDDO
               !
-              iimax = iimax-1
-              jjmax = jjmax-1
+              IF( ln_agrif_domain ) THEN
+                 iimax = iimax-1
+                 jjmax = jjmax-1
+              ELSE
+                 iimax = MAX(iimin,iimax-1)
+                 jjmax = MAX(jjmin,jjmax-1)
+              ENDIF
               !               
               iimin = MAX( iimin,1 )
@@ -324,26 +313,23 @@
 
               IF( nxhr == 0 .OR. nyhr == 0 ) THEN
+                 !
                  trouble_points(ji,jj) = 1
+                 !
               ELSE
-
-                 ALLOCATE( vardep(nxhr,nyhr) )
-                 ALLOCATE( mask_oce(nxhr,nyhr) )
-                 mask_oce = 0       
-
+                 !
+                 ALLOCATE( vardep(nxhr,nyhr), mask_oce(nxhr,nyhr) )
                  vardep(:,:) = G0%bathy_meter(iimin:iimax,jjmin:jjmax)
-
-                 WHERE( vardep(:,:) .GT. 0. )  mask_oce = 1
-
-!                 IF( SUM(mask_oce) == 0 ) THEN
-                 IF( SUM(mask_oce) < 0.5*(nxhr*nyhr) ) THEN
+                 !
+                 WHERE( vardep(:,:) .GT. 0. )   ;   mask_oce = 1 ;
+                 ELSEWHERE                      ;   mask_oce = 0 ;
+                 ENDWHERE
+                 !
+                 IF( SUM(mask_oce) < 0.5*(nxhr*nyhr) ) THEN ! if more than half of the points are on land then bathy fine = 0
                     G1%bathy_meter(ji,jj) = 0.
                  ELSE
-                    IF( type_bathy_interp == 0 ) THEN
-                       ! Arithmetic average                   
-                       G1%bathy_meter(ji,jj) = SUM (vardep(:,:)*mask_oce(:,:))/SUM(mask_oce)
-                    ELSE
-                       ! Median average		    
-                       !
-                       vardep(:,:) = vardep(:,:)*mask_oce(:,:) - 100000*(1-mask_oce(:,:))
+                    IF( type_bathy_interp == 0 ) THEN     ! Arithmetic average
+                       G1%bathy_meter(ji,jj) = SUM( vardep(:,:) * mask_oce(:,:) ) / SUM( mask_oce(:,:) )
+                    ELSE                                  ! Median average
+                       vardep(:,:) = vardep(:,:) * mask_oce(:,:) - 100000 * ( 1 - mask_oce(:,:) )
                        ALLOCATE(vardep1d(nxhr*nyhr))
                        vardep1d = RESHAPE(vardep,(/ nxhr*nyhr /) )
@@ -351,9 +337,8 @@
                        !
                        ! Calculate median
-                       !
                        IF (MOD(SUM(mask_oce),2) .NE. 0) THEN
-                          G1%bathy_meter(ji,jj) = vardep1d( SUM(mask_oce)/2 + 1)
+                          G1%bathy_meter(ji,jj) = vardep1d( SUM(mask_oce)/2 + 1 )
                        ELSE
-                          G1%bathy_meter(ji,jj) = ( vardep1d(SUM(mask_oce)/2) + vardep1d(SUM(mask_oce)/2+1) )/2.0
+                          G1%bathy_meter(ji,jj) = 0.5 * ( vardep1d(SUM(mask_oce)/2) + vardep1d(SUM(mask_oce)/2+1) )
                        END IF
                        DEALLOCATE(vardep1d)   
@@ -361,5 +346,5 @@
                  ENDIF
                  DEALLOCATE (mask_oce,vardep)
-
+                 !
               ENDIF
            ENDDO
@@ -367,31 +352,23 @@
 
         IF( SUM( trouble_points ) > 0 ) THEN
-           PRINT*,'too much empty cells, proceed to bilinear interpolation !!'
+           PRINT*,'too much empty cells, proceed to bilinear interpolation'
            type_bathy_interp = 2
         ENDIF
-
-     ENDIF
-
-     !
-     ! create logical array masksrc
-     !
-     IF( type_bathy_interp == 2) THEN 
-        !
-
-        !            
+           
+     ENDIF
+     !                                                       ! ----------------------------- 
+     IF( type_bathy_interp == 2) THEN                        ! Bilinear interpolation
+        !                                                    ! ----------------------------- 
         identical_grids = .FALSE.
 
-        IF( SIZE(G0%nav_lat,1) == SIZE(G1%nav_lat,1)  .AND.   &
-             SIZE(G0%nav_lat,2) == SIZE(G1%nav_lat,2)  .AND.   &
-             SIZE(G0%nav_lon,1) == SIZE(G1%nav_lon,1)  .AND.   &
-             SIZE(G0%nav_lon,2) == SIZE(G1%nav_lon,2)   ) THEN
+        IF( SIZE(G0%nav_lat,1) == SIZE(G1%nav_lat,1) .AND. SIZE(G0%nav_lat,2) == SIZE(G1%nav_lat,2)  .AND.   &
+            SIZE(G0%nav_lon,1) == SIZE(G1%nav_lon,1) .AND. SIZE(G0%nav_lon,2) == SIZE(G1%nav_lon,2) ) THEN
            IF( MAXVAL( ABS(G0%nav_lat(:,:)- G1%nav_lat(:,:)) ) < 0.0001 .AND.   &
-                MAXVAL( ABS(G0%nav_lon(:,:)- G1%nav_lon(:,:)) ) < 0.0001 ) THEN
+               MAXVAL( ABS(G0%nav_lon(:,:)- G1%nav_lon(:,:)) ) < 0.0001 ) THEN
+              PRINT*,'same grid between ',elevation_database,' and child domain'    
               G1%bathy_meter = G0%bathy_meter 
-              PRINT*,'same grid between ',elevation_database,' and child domain'    
               identical_grids = .TRUE.                          
            ENDIF
         ENDIF
-
 
         IF( .NOT. identical_grids ) THEN 
@@ -400,19 +377,13 @@
            ALLOCATE(bathy_test(nxfin,nyfin))
            !
-           !                    Where(G0%bathy_meter.le.0.00001) 
-           !	                masksrc = .false.
-           !	            ElseWhere
-           !
-           masksrc = .TRUE.
-           !
-           !	            End where                       
+           !Where(G0%bathy_meter.le.0.00001) 
+           !  masksrc = .false.
+           !ElseWhere
+              masksrc = .TRUE.
+           !End where                       
            !            
            ! compute remapping matrix thanks to SCRIP package            
-           !                                  
-           CALL get_remap_matrix(G0%nav_lat,G1%nav_lat,   &
-                G0%nav_lon,G1%nav_lon,   &
-                masksrc,matrix,src_add,dst_add)
-           CALL make_remap(G0%bathy_meter,bathy_test,nxfin,nyfin, &
-                matrix,src_add,dst_add)  
+           CALL get_remap_matrix(G0%nav_lat,G1%nav_lat,G0%nav_lon,G1%nav_lon,masksrc,matrix,src_add,dst_add)
+           CALL make_remap(G0%bathy_meter,bathy_test,nxfin,nyfin,matrix,src_add,dst_add)  
            !                                  
            G1%bathy_meter = bathy_test               
